package com.bizmatics.mhfire.service.util;

/**
 * @author yq
 * @date 2021/8/19 15:51
 */
public class CaculateDistance {

    private final static double EARTH_RADIUS = 6378.137;

    private static double rad(double d) {
        return d * Math.PI / 180.0;
    }

    /**
     * 根据两点间经纬度坐标（double值），计算两点间距离，单位为米
     */
    public static double getDistance(double latOne, double lngOne, double latTwo, double lngTwo) {
        double radLat1 = rad(latOne);
        double radLat2 = rad(latTwo);
        double a = radLat1 - radLat2;
        double b = rad(lngOne) - rad(lngTwo);
        double s = 2 * Math.asin(Math.sqrt(
                Math.pow(Math.sin(a / 2), 2) + Math.cos(radLat1) * Math.cos(radLat2) * Math.pow(Math.sin(b / 2), 2)));
        s = s * EARTH_RADIUS;
        s = (s * 10000) / 10;
        return s;
    }
}
